<?

/*

CMSimple WDir plugin
 2006 - Joachim Barthel - www.qualifire.de/cmsimple/en
---------------------------------------------------------------------
Disclaimer:   No warranties at all, use on your own risk !
---------------------------------------------------------------------
Requirements: - CMSimple 2.5 is installed and running.
              - The plugin loader from cmsimpleplugins.svarrer.dk 
                is installed and working !
---------------------------------------------------------------------
Feedback to:  jbarthel@qualifire.de
---------------------------------------------------------------------

Version 0.1 beta 1  (03. June 2006)
  - Support for multilingual use
  - Enhancements of display
  - first options

Version 0.1 beta 1a  (04. June 2006)
  - Help files (en & de)
  - new option for summary

Version 0.1 beta 2 (03. July 2006)
  - Slovak language support (Thanks to Martin Sereday)
  - Display of file attributes
  - Error trapping of wrong path
  - Formatting with CSS
  - Error on counting the files

Version 0.1 beta 2a (26. July 2006)
  - Option for hidden files (starting with dot-character)

Version 0.1 beta 3 (03. September 2006)
  - Show/Hide option for Size and Date columns
  - Open mode added
  
*/



function wd_Version() {
   return "0.3 beta";
}



function wd_list($wd_PathParam) {

	GLOBAL $su, $sl, $plugin_cf, $plugin_tx, $pth, $plugin;

	//$wd_version = "0.1 beta 2a";
	error_reporting(E_ALL);

	$wdo = "";
	$wdo .= "<!-- QualiFIREs WebDirectory >>WDir<< Code starts here -->\n<div><br>\n";

	if (substr($wd_PathParam,-1,1) <> "/") $wd_PathParam .= "/";
	if (($wd_PathParam == "./") || ($wd_PathParam == "/")) $wd_PathParam = "";
	if (substr($wd_PathParam,0,2) == "./") $wd_PathParam = substr($wd_PathParam,2);
	$wd_path = $pth['folder']['base'] . $wd_PathParam;
	if(eregi("true",$plugin_cf['wdir']['debug'])) {
		$wdo .= "Path-Parameter: $wd_PathParam<br>";
		$wdo .= "Fileserver-Dir: $wd_path<br>";
		$wdo .= "HTTP_HOST: " . $_SERVER['HTTP_HOST'] . "<br>";
		$wdo .= "PHP_SELF: " . $_SERVER['PHP_SELF'] . "<br>";
		$wdo .= "<hr>";
	}
	$d = dir($wd_path);

	$wd_fnames = array();
	$wd_ftypes = array();
	$fcount = 0;
	while (false !== ($entry = $d->read())) {
		if ($entry != "." && $entry != "..") {
			if ((eregi("true",$plugin_cf['wdir']['show_hiddenfiles'])) || (substr($entry,0,1) != '.')) {
				$fcount++;
				array_push($wd_fnames, $entry);
				array_push($wd_ftypes, filetype($wd_path."/".$entry));
			}
		}
	}
	$d->close();
	$fcount--;

	$wd_lowfnames = array_map('strtolower', $wd_fnames);
	array_multisort($wd_ftypes, $wd_lowfnames, $wd_fnames);
	$wd_http = "http://" . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'];
	$wd_http = substr($wd_http,0,strrpos($wd_http,'/')+1);
	if (substr($wd_http,-4,4) == '/'.$sl.'/') $wd_http = substr($wd_http,0,strlen($wd_http)-3);
   
   if(eregi("true",$plugin_cf['wdir']['show_path'])) {
     $wdo .=  "<span class=\"wdPath\">"
        . "&nbsp;Path: <strong>" . $wd_http.$wd_PathParam. "&nbsp;</strong>"
        . "</span><br /> <br>\n";
   }
        
	$wdo .= "<table>";
	if(eregi("true",$plugin_cf['wdir']['show_colheader'])) {
		$wdo .= "<tr>";
		$wdo .= "<td colspan=\"3\" class=\"wdColHeader\">" . $plugin_tx['wdir']['txt_name'] . "</td>";
		if(eregi("true",$plugin_cf['wdir']['show_size'])) 
			$wdo .= "<td colspan=\"3\" class=\"wdColHeader\">" . $plugin_tx['wdir']['txt_size'] . "</td>";
			
		if(eregi("true",$plugin_cf['wdir']['show_changed'])) 
			$wdo .= "<td class=\"wdColHeader\">" . $plugin_tx['wdir']['txt_changed'] . "</td>";
			
		if(eregi("true",$plugin_cf['wdir']['show_attributes'])) 
			$wdo .= "<td colspan=\"2\" class=\"wdColHeader\">" . $plugin_tx['wdir']['txt_perms'] . "</td>";
		
		$wdo .= "</tr>";
	}
   
   $wd_total = 0;
   for ($i = 0; $i <= $fcount; $i++) {
      $wd_fext = substr($wd_fnames[$i],strrpos($wd_fnames[$i],".")+1);
      //if (filetype($fullname) == "dir") $wd_fext = "DIR";
      $fullname = $wd_path . "/" . $wd_fnames[$i];
      if (filetype($fullname) == "dir") {
         /*
         $wdo .= "<tr>";
         $wd_fext = "DIR";
         $wdo .= "<td><img src=\"" . wd_FileIcon($wd_fext) . "\"></td><td></td>";
         $wdo .= "<td>". $wd_fnames[$i] . "</td><td>&nbsp;&nbsp;</td>";
         $wdo .= "<td></td><td>&nbsp;&nbsp;</td>";
         //$wdo .= "<td>Dateiordner</td><td>&nbsp;&nbsp;</td>";
         $wdo .= "<td>" . date("d.m.Y H:i:s", filemtime($fullname)) . "</td>";
         $wdo .= "</tr>\n";
         */
      } else {
         $wdo .= "<tr>";
         $wdo .= "<td><img src=\"" . wd_FileIcon($wd_fext) . "\"></td><td></td>";
         $wdo .= "<td><a href=\"" .$wd_http . $wd_PathParam .$wd_fnames[$i]. "\" target=\"" . $plugin_cf['wdir']['open_mode'] . "\">". $wd_fnames[$i] . "</a></td>";
         if(eregi("true",$plugin_cf['wdir']['show_size'])) 
         	$wdo .= "<td>&nbsp;&nbsp;</td><td align=\"right\">". number_format(filesize($fullname),0,',','.') . " Bytes</td><td>&nbsp;&nbsp;</td>";
         	
         $wd_total += filesize($fullname);
         //$wdo .= "<td>".strtoupper($wd_fext)."-Datei</td><td>&nbsp;&nbsp;</td>";
         if(eregi("true",$plugin_cf['wdir']['show_changed'])) 
         	$wdo .= "<td>" . date("d.m.Y H:i:s", filemtime($fullname)) . "</td>";
         	
         if(eregi("true",$plugin_cf['wdir']['show_attributes'])) {
            //$wdo .= "<td></td><td>".decoct(fileperms($fullname))."</td>";
            $wdo .= "<td></td><td>".wd_FilePerms(decoct(fileperms($fullname)))."</td>";
         }
         
         $wdo .= "</tr>\n";
      }
   }
   $wdo .= "</table><br>";
   if(eregi("true",$plugin_cf['wdir']['show_summary'])) {
     $fcount++;
     $wdo .=  "<span class=\"wdSummary\">"
        . "&nbsp;" . $fcount . "&nbsp;" . $plugin_tx['wdir']['txt_files'] . ",&nbsp;" . number_format($wd_total,0,',','.') . "&nbsp;Bytes"
        . "</span><br /> <br>\n";
   }

   if(eregi("true",$plugin_cf['wdir']['show_creator'])) {
      $wdo .= "<div style=\"text-align: center; font-size: 0.75em; display: block\">";
   } else {
      $wdo .= "<div style=\"text-align: center; font-size: 0.75em; display: none\">";
   }
   $wdo .= "<br>&nbsp;<br><span style=\"border-top: 1px solid; padding-top: 2px; color:#666666;\">&nbsp;&nbsp;&nbsp;Webdirectory plugin, Ver. " . wd_version() . " by <a href=\"http://www.qualifire.de/cmsimple\" target=\"_blank\">QualiFIRE</a>&nbsp;&nbsp;&nbsp;</span>";
   $wdo .= "</div>";

   $wdo .= "<br></div>";
   $wdo .= "\n<!-- QualiFIREs WebDirectory >>WDir<< Code ends here -->\n";
   
   return $wdo;
}



function wd_FileIcon($wd_fext) {

	GLOBAL $su, $sl, $plugin_cf, $plugin_tx, $pth, $plugin;

	$wd_FullPath = $pth['folder']['plugins']."wdir/images/" . strtoupper($wd_fext) . "icon.gif";
	if (!file_exists($wd_FullPath)) $wd_FullPath = $pth['folder']['plugins']."wdir/images/" . "UFO" . "icon.gif";
  
	return $wd_FullPath;

}


function wd_FilePerms($fperms) {
	$cRet = "<table><tr>";
	for ($i=3; $i<=5; $i++) {
		$cOctAcc = intval(substr($fperms,$i,1));
		if ($cOctAcc-4 >= 0) {
			$cOctAcc -= 4;
			$cChrAcc = "<td class=\"wdFilePerms\">R</td>";
		} else {
			$cChrAcc = "<td class=\"wdFilePerms\">-</td>";
		}
		if ($cOctAcc-2 >= 0) {
			$cOctAcc -= 2;
			$cChrAcc .= "<td class=\"wdFilePerms\">W</td>";
		} else {
			$cChrAcc .= "<td class=\"wdFilePerms\">-</td>";
		}
		if ($cOctAcc == 1) {
			//$cOctAcc -= 2;
			$cChrAcc .= "<td class=\"wdFilePerms\">X</td>";
		} else {
			$cChrAcc .= "<td class=\"wdFilePerms\">-</td>";
		}
		
		$cRet .= $cChrAcc;
		$cRet .= "<td>&nbsp;</td>";
	}
	$cRet .= "</tr></table>";
	return $cRet;
}



?>